> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/web/get-started/guides/page-manipulation.md).

# Applying page manipulations to PDFs directly in the client

Enhance PDFs directly in the client with page manipulations using WebViewer. Rotate, crop, reorder, add, or delete pages seamlessly for visible changes in any PDF viewer. The Apryse Web SDK streamline

When WebViewer is running in [client only mode](/web/what-is-webviewer/deployment-options.md#client-only) it is able to perform many different kinds of page manipulations. These include rotating, cropping, reordering, adding, and deleting pages. Instead of temporarily modifying the document in the viewer, these operations modify the actual PDF data.

This means that when the download button is pressed or [getFileData](https://sdk.apryse.com/api/web/Core.Document.html#getFileData__anchor) is called, the returned PDF will have the manipulations applied and they will be visible in any PDF viewer.

{% hint style="warning" %}
If you're using the WebViewer Server deployment option then you'll need to enable the `forceClientSideInit: true` constructor option. This will initialize the document with WebViewer Server and then switch to client side processing.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/web/get-started/guides/page-manipulation.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
